Package: AnalyzeFMRI
Version: 1.1-25
Date: 2025-07-11
Title: Functions for Analysis of fMRI Datasets Stored in the ANALYZE or
        'NIFTI' Format
Author: Pierre Lafaye De Micheaux [aut, cre],
  Jonathan L Marchini [aut],
  Cleve Moler [cph] (LAPACK/BLAS routines in src),
  Jack Dongarra [cph] (LAPACK/BLAS routines in src),
  Richard Hanson [cph] (LAPACK/BLAS routines in src),
  Sven Hammarling [cph] (LAPACK/BLAS routines in src),
  Jeremy Du Croz [cph] (LAPACK/BLAS routines in src)
Authors@R: c(person("Pierre", "Lafaye De Micheaux", role = c("aut", "cre"),
	             email = "lafaye@unsw.edu.au"),
             person("Jonathan L", "Marchini", role = c("aut"),
                    email = "jonathan.marchini@regeneron.com"),
	     person("Cleve", "Moler", role = "cph",
	            comment = "LAPACK/BLAS routines in src"),
	     person("Jack", "Dongarra", role = "cph",
	            comment = "LAPACK/BLAS routines in src"),
	     person("Richard", "Hanson", role = "cph",
	            comment = "LAPACK/BLAS routines in src"),
	     person("Sven", "Hammarling", role = "cph",
	            comment = "LAPACK/BLAS routines in src"),
	     person("Jeremy", "Du Croz", role = "cph",
	            comment = "LAPACK/BLAS routines in src"))
Maintainer: Pierre Lafaye De Micheaux <lafaye@unsw.edu.au>
Depends: R (>= 4.4.0), R.matlab, fastICA, tcltk
Suggests: tkrplot
Description: Functions for I/O, visualisation and analysis of functional Magnetic Resonance Imaging (fMRI) datasets stored in the ANALYZE or 'NIFTI' format. Note that the latest version of 'XQuartz' seems to be necessary under MacOS.
License: GPL (>= 2)
Packaged: 2025-07-23 01:43:41 UTC; lafaye
Copyright: For LAPACK/BLAS routines in src (Univ. of Tennessee, Univ.
        of California Berkeley, NAG Ltd., Courant Institute, Argonne
        National Lab, and Rice University).
NeedsCompilation: yes
Repository: CRAN
Date/Publication: 2025-07-24 12:50:12 UTC
Built: R 4.6.0; aarch64-apple-darwin23; 2026-04-26 05:32:33 UTC; unix
Archs: AnalyzeFMRI.so.dSYM

useDynLib(AnalyzeFMRI, .registration = TRUE)

# Export all names
exportPattern(".")

# Import all packages listed as Imports or Depends
import(
  tcltk,
  R.matlab,
  fastICA
)

importFrom("grDevices", "dev.off", "heat.colors", "jpeg")
importFrom("graphics", "abline", "axis", "box", "image", "par", "plot",
           "points", "text")
importFrom("stats", "dgamma", "dnorm", "fft", "median", "optim",
           "optimize", "pf", "pnorm", "pt", "qf", "qgamma", "qnorm",
           "qt", "quantile", "rnorm", "sd")
importFrom("utils", "glob2rx", "write.table")

  maColorBar <- function (x, horizontal = TRUE, col = heat.colors(50), scale = 1:length(x),
                          k = 10, ...)
    {
      if (is.numeric(x)) {
        x <- x
        colmap <- col
      }
      else {
        colmap <- x
        low <- range(scale)[1]
        high <- range(scale)[2]
        x <- seq(low, high, length = length(x))
      }
      if (length(x) > k)
        x.small <- seq(x[1], x[length(x)], length = k)
      else x.small <- x
      if (horizontal) {
        image(x, 1, matrix(x, length(x), 1), axes = FALSE, xlab = "",
              ylab = "", col = colmap, ...)
        axis(1, at = rev(x.small), labels = signif(rev(x.small),
                                     2), srt = 270)
      }
      if (!horizontal) {
        image(1, x, matrix(x, 1, length(x)), axes = FALSE, xlab = "",
              ylab = "", col = colmap, ...)
        oldpar <- par(las = 1)
        axis(4, at = rev(x.small), labels = signif(rev(x.small),2))
        par(las = 0)
        par(oldpar)
      }
      box()
    }

  gui.file.fonc <- function(){
    tcltk::tclvalue(file.name.fonc) <- tcltk::tcl("tk_getOpenFile")   }
    
  gui.file.anat <- function(){
    tcltk::tclvalue(file.name.anat) <- tcltk::tcl("tk_getOpenFile")  }    
    
  gui.file.time.series <- function(){
    tcltk::tclvalue(file.name.time.series) <- tcltk::tcl("tk_getOpenFile")  }    


  plot.volume <- function(vol.fonc="",vol.anat="",time.series="", envir = NULL) {

  ## !!! J'ai pris method=3 (lecture de la matrice affine) pour faire conincider l'anat et la fonctionnelle
  ### si sform.code=0 cela ne marchera pas ...
    method <- 3
    
    hscaletmp <- as.numeric(tcltk::tclvalue(hscaletmp))
    vscaletmp <- as.numeric(tcltk::tclvalue(vscaletmp))
  
# Permet d'afficher un volume cérébral anatomique et/ou fonctionnel
# Paramètres d'entrée:
#	vol.fonc: nom du fichier (.img ou .nii) ou bien une array 4D contenant les images volumiques fonctionnelles
#	vol.anat: nom du fichier (.img ou .nii) ou bien une array 4D contenant les images volumiques anatomiques
#       time.series : fichier .dat contenant les composantes temporelles extraites par l'ICA  


  # J'ai rajouté cela à la fonction plot.volume pour qu'elle soit appelable par le tkwidget
    vol.fonc <- tcltk::tclvalue(file.name.fonc)
    vol.anat <- tcltk::tclvalue(file.name.anat)
    time.series <- tcltk::tclvalue(file.name.time.series)

    is.vol.fonc <- FALSE
    is.vol.anat <- FALSE
    is.time.series <- FALSE
  
    if (nzchar(vol.fonc)[1]) is.vol.fonc <- TRUE
    if (nzchar(vol.anat)[1]) is.vol.anat <- TRUE
    if (nzchar(time.series)[1]) is.time.series <- TRUE
    
    my.title.fonc <- "FMRI visualization:"
    my.title.anat <- "MRI visualization:"

    scanText.fonc <- tcltk::tclVar("Scanner coordinates: ")
    scanText.anat <- tcltk::tclVar("Scanner coordinates: ")

    
    if (is.vol.fonc) {
      
      if (exists(vol.fonc)) vol.fonc <- get(vol.fonc)

      col.fonc <- heat.colors(256)    
    
      if (is.character(vol.fonc)) { # reading of the image
        my.title.fonc <- paste(my.title.fonc,vol.fonc)
        hdr.fonc <- f.read.header(vol.fonc)

        # I added that so that no error is output when visualizing ANALYZE images. But really not sure this is correct!
        file <- vol.fonc
        is.nii <- substring(file, nchar(file) - 2,nchar(file)) # file extension
        file.name <- substring(file, 1, nchar(file) - 4) # file name without extension
        if (is.nii == "nii") {
          file.hdr <- paste(file.name, ".nii", sep = "")
        } 
        else {
         file.hdr <- paste(file.name, ".hdr", sep = "")
         if(file.exists(file.hdr) == FALSE) stop(paste(file.hdr, "not found"))
        }
        a <- substr(.C("read_nifti_magic_wrap", file.hdr, 0L, magic =  paste(rep(" ", 4), sep = "", collapse = ""), PACKAGE = "AnalyzeFMRI")$magic, start = 1, stop = 2)
        if (a == "") { # Old ANALYZE format
          method <- 1
          hdr.fonc$sform.code <- 0
          hdr.fonc$qform.code <- 0
          }


        
        vol.fonc <- f.read.volume(vol.fonc)



        # if flip.fonc == - 1 :Radiological else if flip.fonc == 1: Neurological
        flip.fonc <- orientation(hdr.fonc)
            
      } else {
        if (!exists("flip.fonc")) print("You must create variable flip.fonc (-1 for Radiological and 1 for Neurological)")
        if (length(dim(vol.fonc)) == 3) {
          vol.fonc <- array(vol.fonc,dim=c(dim(vol.fonc),1))
        } else {vol.fonc <- vol.fonc}
      }
    
      dimensions.fonc <- dim(vol.fonc)
      dim.fonc.sagit <- dimensions.fonc[1]
      dim.fonc.coron <- dimensions.fonc[2]
      dim.fonc.axia <- dimensions.fonc[3]
      dim.fonc.time <- dimensions.fonc[4]
    
# Variable initialisation
      nn.fonc.sagit <- ceiling(dim.fonc.sagit/2)
      nn.fonc.coron <- ceiling(dim.fonc.coron/2)
      nn.fonc.axia <- ceiling(dim.fonc.axia/2)
      nn.fonc.time <- 1
    
      mini.fonc <- min(vol.fonc[,,,nn.fonc.time],na.rm=TRUE)
      maxi.fonc <- max(vol.fonc[,,,nn.fonc.time],na.rm=TRUE)
      if ((mini.fonc-maxi.fonc) == 0) maxi.fonc <- maxi.fonc+0.00001
      breaks.fonc <- c(seq(from=mini.fonc,to=0,len=length(col.fonc)/2),seq(from=0,to=maxi.fonc,len=length(col.fonc)/2+1)) 
    
      SliderSagit.fonc <- tcltk::tclVar(dim.fonc.sagit)
      SliderCoron.fonc <- tcltk::tclVar(dim.fonc.coron)
      SliderAxia.fonc <- tcltk::tclVar(dim.fonc.axia)
      SliderTime.fonc <- tcltk::tclVar(dim.fonc.time)

    }

    if (is.vol.anat) {

      if (exists(vol.anat)) vol.anat <- get(vol.anat)
      
      col.anat <- gray(seq(from=0.2,to=1,len=256))

      if (is.character(vol.anat)) { # reading of the image
        my.title.anat <- paste(my.title.anat,vol.anat)
        hdr.anat <- f.read.header(vol.anat)


        # I added that so that no error is output when visualizing ANALYZE images. But really not sure this is correct!
        file <- vol.anat
        is.nii <- substring(file, nchar(file) - 2,nchar(file)) # file extension
        file.name <- substring(file, 1, nchar(file) - 4) # file name without extension
        if (is.nii == "nii") {
          file.hdr <- paste(file.name, ".nii", sep = "")
        } 
        else {
         file.hdr <- paste(file.name, ".hdr", sep = "")
         if(file.exists(file.hdr) == FALSE) stop(paste(file.hdr, "not found"))
        }
        a <- substr(.C("read_nifti_magic_wrap", file.hdr, 0L, magic =  paste(rep(" ", 4), sep = "", collapse = ""), PACKAGE = "AnalyzeFMRI")$magic, start = 1, stop = 2)
        if (a == "") { # Old ANALYZE format
          method <- 1
          hdr.fonc$sform.code <- 0
          hdr.fonc$qform.code <- 0
          }

        

        vol.anat <- f.read.volume(vol.anat)

        # if flip.anat == - 1 :Radiological else if flip.anat == 1: Neurological
        flip.anat <- orientation(hdr.anat)

      }
      if (!exists("flip.anat")) print("You must create variable flip.anat (-1 for Radiological and 1 for Neurological)")

      if (length(dim(vol.anat)) == 4) vol.anat <- vol.anat[,,,1]
      if (length(dim(vol.anat)) == 2) dim(vol.anat) <- c(dim(vol.anat),1)
    
      dimensions.anat <- dim(vol.anat)
      dim.anat.sagit <- dimensions.anat[1]
      dim.anat.coron <- dimensions.anat[2]
      dim.anat.axia <- dimensions.anat[3]
    
      mini.anat <- min(vol.anat[,,],na.rm=TRUE)
      maxi.anat <- max(vol.anat[,,],na.rm=TRUE)
      if ((mini.anat-maxi.anat) == 0) maxi.anat <- maxi.anat+0.00001
      breaks.anat <- seq(from=mini.anat,to=maxi.anat,len=length(col.anat)+1)
  
  
# Variable initialisation
      nn.anat.sagit <- ceiling(dim.anat.sagit/2)
      nn.anat.coron <- ceiling(dim.anat.coron/2)
      nn.anat.axia <- ceiling(dim.anat.axia/2)
      
      SliderSagit.anat <- tcltk::tclVar(dim.anat.sagit)
      SliderCoron.anat <- tcltk::tclVar(dim.anat.coron)
      SliderAxia.anat <- tcltk::tclVar(dim.anat.axia)

    }

    
    
    if (is.vol.fonc) {
    
# Useful functions
      f.fonc.sagit <- function(...) {
        n.fonc.sagit <- as.numeric(tcltk::tclvalue("nn.fonc.sagit"))
        n.fonc.time <- as.numeric(tcltk::tclvalue("nn.fonc.time"))
        if (n.fonc.sagit != nn.fonc.sagit) {
        #  nn.fonc.sagit <<- n.fonc.sagit
        assign("nn.fonc.sagit", n.fonc.sagit, envir = envir)
          tkrplot::tkrreplot(img.fonc.sagit)
          tkrplot::tkrreplot(img.fonc.coron)
          tkrplot::tkrreplot(img.fonc.axia)
          tkrplot::tkrreplot(img.fonc.palette)

          ijk.fonc <- c(nn.fonc.sagit,nn.fonc.coron,nn.fonc.axia)
          xyz.fonc <- ijk2xyz(ijk.fonc,method=method,hdr.fonc)$xyz
          tcltk::tclvalue(scanText.fonc) <- paste("Scanner coordinates:",paste(round(xyz.fonc,2),collapse=","))

        }
        if (n.fonc.time != nn.fonc.time) {
#          nn.fonc.time <<- n.fonc.time
assign("nn.fonc.time", n.fonc.time, envir = envir)

          tkrplot::tkrreplot(img.fonc.sagit)
          tkrplot::tkrreplot(img.fonc.coron)
          tkrplot::tkrreplot(img.fonc.axia)
          tkrplot::tkrreplot(img.fonc.palette)
        }
      }
      
      f.fonc.coron <- function(...) {
        n.fonc.coron <- as.numeric(tcltk::tclvalue("nn.fonc.coron"))
        n.fonc.time <- as.numeric(tcltk::tclvalue("nn.fonc.time"))
        if (n.fonc.coron != nn.fonc.coron) {
#          nn.fonc.coron <<- n.fonc.coron
assign("nn.fonc.coron", n.fonc.coron, envir = envir)

          tkrplot::tkrreplot(img.fonc.sagit)
          tkrplot::tkrreplot(img.fonc.coron)
          tkrplot::tkrreplot(img.fonc.axia)
          tkrplot::tkrreplot(img.fonc.palette)

          ijk.fonc <- c(nn.fonc.sagit,nn.fonc.coron,nn.fonc.axia)
          xyz.fonc <- ijk2xyz(ijk.fonc,method=method,hdr.fonc)$xyz
          tcltk::tclvalue(scanText.fonc) <- paste("Scanner coordinates:",paste(round(xyz.fonc,2),collapse=","))

        }
        if (n.fonc.time != nn.fonc.time) {
#          nn.fonc.time <<- n.fonc.time
assign("nn.fonc.time", n.fonc.time, envir = envir)

          tkrplot::tkrreplot(img.fonc.sagit)
          tkrplot::tkrreplot(img.fonc.coron)
          tkrplot::tkrreplot(img.fonc.axia)
          tkrplot::tkrreplot(img.fonc.palette)
        }
      }
      
      f.fonc.axia <- function(...) {
        n.fonc.axia <- as.numeric(tcltk::tclvalue("nn.fonc.axia"))
        n.fonc.time <- as.numeric(tcltk::tclvalue("nn.fonc.time"))
        if (n.fonc.axia != nn.fonc.axia) {
#        nn.fonc.axia <<- n.fonc.axia
assign("nn.fonc.axia", n.fonc.axia, envir = envir)

        tkrplot::tkrreplot(img.fonc.sagit)
        tkrplot::tkrreplot(img.fonc.coron)
        tkrplot::tkrreplot(img.fonc.axia)
        tkrplot::tkrreplot(img.fonc.palette)

        ijk.fonc <- c(nn.fonc.sagit,nn.fonc.coron,nn.fonc.axia)
        xyz.fonc <- ijk2xyz(ijk.fonc,method=method,hdr.fonc)$xyz
        tcltk::tclvalue(scanText.fonc) <- paste("Scanner coordinates:",paste(round(xyz.fonc,2),collapse=","))

      }
        if (n.fonc.time != nn.fonc.time) {
#          nn.fonc.time <<- n.fonc.time
assign("nn.fonc.time", n.fonc.time, envir = envir)

          tkrplot::tkrreplot(img.fonc.sagit)
          tkrplot::tkrreplot(img.fonc.coron)
          tkrplot::tkrreplot(img.fonc.axia)
          tkrplot::tkrreplot(img.fonc.palette)
        }
      }
        
      f.fonc.time <- function(...) {
        n.fonc.time <- as.numeric(tcltk::tclvalue("nn.fonc.time"))
        if (n.fonc.time != nn.fonc.time) {
#          nn.fonc.time <<- n.fonc.time
assign("nn.fonc.time", n.fonc.time, envir = envir)
#          mini.fonc <<- min(vol.fonc[,,,nn.fonc.time],na.rm=TRUE)
assign("mini.fonc", min(vol.fonc[,,,nn.fonc.time],na.rm=TRUE), envir = envir)
#          maxi.fonc <<- max(vol.fonc[,,,nn.fonc.time],na.rm=TRUE)
assign("maxi.fonc", max(vol.fonc[,,,nn.fonc.time],na.rm=TRUE), envir = envir)
          if ((mini.fonc-maxi.fonc) == 0) assign("maxi.fonc", maxi.fonc+0.00001, envir = envir) # maxi.fonc <<- maxi.fonc+0.00001
#          breaks.fonc <<- c(seq(from=mini.fonc,to=0,len=length(col.fonc)/2),seq(from=0,to=maxi.fonc,len=length(col.fonc)/2+1)) 
assign("breaks.fonc", c(seq(from=mini.fonc,to=0,len=length(col.fonc)/2),seq(from=0,to=maxi.fonc,len=length(col.fonc)/2+1)), envir = envir)
          tkrplot::tkrreplot(img.fonc.sagit)
          tkrplot::tkrreplot(img.fonc.coron)
          tkrplot::tkrreplot(img.fonc.axia)
          tkrplot::tkrreplot(img.fonc.palette)
          if (is.time.series) tkrplot::tkrreplot(img.time.series)
        }
      }
    
      OnOK.fonc <- function() {tcltk::tkdestroy(tt.fonc);if (is.time.series) tcltk::tkdestroy(tt.fonc.time.series)}
    
  #set up base GUI window
      if(.Platform$OS.type == "windows") flush.console()
    
      tt.fonc <- tcltk::tktoplevel(bg="#555555")

      tcltk::tkwm.title(tt.fonc, my.title.fonc)
    
            
  # frame 1 to contain images
      frame1.fonc <- tcltk::tkframe(tt.fonc, relief = "groove", borderwidth = 0, bg = "#555555")
      label.fonc.sagit <- tcltk::tklabel(frame1.fonc,text="Sagittal ", bg = "#aaaaaa")
      label.fonc.coron <- tcltk::tklabel(frame1.fonc,text="Coronal ", bg = "#aaaaaa")
      slider.fonc.sagit <- tcltk::tkscale(frame1.fonc, command=f.fonc.sagit, from=as.numeric(tcltk::tclvalue(SliderSagit.fonc)), to=1, variable="nn.fonc.sagit",showvalue=TRUE, resolution=1, orient="verti",label="X") 
      img.fonc.sagit <- tkrplot::tkrplot(parent=frame1.fonc, fun=function() {
        oldpar <- par(mar=c(0,0,0,0), bg = "#555555")
    # coupe sagittale
        image((1:dim.fonc.coron)/abs(hdr.fonc$pixdim[3]),(1:dim.fonc.axia)/abs(hdr.fonc$pixdim[4]),as.matrix(vol.fonc[if (flip.fonc == -1) dim.fonc.sagit-nn.fonc.sagit+1 else nn.fonc.sagit,,,nn.fonc.time]),col=col.fonc,breaks=breaks.fonc,axes=FALSE,xlab="",ylab="",asp=dim.fonc.coron/dim.fonc.axia)
        abline(h=nn.fonc.axia/abs(hdr.fonc$pixdim[4]),v=nn.fonc.coron/abs(hdr.fonc$pixdim[3]),col="black")
        par(oldpar)
    }
                              , hscale=hscaletmp, vscale=vscaletmp)
      tcltk::tkbind(img.fonc.sagit, "<Button-1>", function(x, y) {
#        asp <- 2
        wid.fonc <- as.integer(tcltk::tkwinfo("width", img.fonc.sagit))
        hei.fonc <- as.integer(tcltk::tkwinfo("height", img.fonc.sagit))

        y0 <- (hei.fonc - hei.fonc * abs(hdr.fonc$pixdim[3]) / abs(hdr.fonc$pixdim[4])) / 2

        
        #        if (as.numeric(y)>(hei.fonc/2 - dim.fonc.axia*wid.fonc/dim.fonc.coron) & as.numeric(y)<(hei.fonc/2 + dim.fonc.axia*wid.fonc/dim.fonc.coron)) {
        if (as.numeric(y) >= y0 & as.numeric(y) <= (hei.fonc - y0)) {
#          nn.fonc.coron <<- ceiling(dim.fonc.coron * as.numeric(x) /wid.fonc)
assign("nn.fonc.coron", ceiling(dim.fonc.coron * as.numeric(x) /wid.fonc), envir = envir)
#          nn.fonc.axia <<- ceiling(dim.fonc.axia/2 + dim.fonc.coron*(hei.fonc/2-as.numeric(y))/(wid.fonc*asp))



#        nn.fonc.axia <<- ceiling( dim.fonc.axia - dim.fonc.axia * (as.numeric(y) - y0) / (hei.fonc - 2 * y0) )
assign("nn.fonc.axia", ceiling( dim.fonc.axia - dim.fonc.axia * (as.numeric(y) - y0) / (hei.fonc - 2 * y0) ), envir = envir)
#        if (as.numeric(y) < y0) nn.fonc.axia <<- dim.fonc.axia
#        if (as.numeric(y) > (hei.fonc - y0)) nn.fonc.axia <<- 1

          

          
          tcltk::tkset(slider.fonc.coron,nn.fonc.coron)
          tcltk::tkset(slider.fonc.axia,nn.fonc.axia)
          tkrplot::tkrreplot(img.fonc.sagit)
          tkrplot::tkrreplot(img.fonc.coron)
          tkrplot::tkrreplot(img.fonc.axia)
          tkrplot::tkrreplot(img.fonc.palette)

          ijk.fonc <- c(nn.fonc.sagit,nn.fonc.coron,nn.fonc.axia)
          xyz.fonc <- ijk2xyz(ijk.fonc,method=method,hdr.fonc)$xyz
          tcltk::tclvalue(scanText.fonc) <- paste("Scanner coordinates:",paste(round(xyz.fonc,2),collapse=","))
          
          if (is.vol.anat) {
            tmp <- round(xyz2ijk(xyz.fonc,method=method,hdr.anat)$ijk)
#            nn.anat.sagit <<- tmp[1]
assign("nn.anat.sagit", tmp[1], envir = envir)
#            nn.anat.coron <<- tmp[2]
assign("nn.anat.coron", tmp[2], envir = envir)
#            nn.anat.axia <<- tmp[3]
assign("nn.anat.axia", tmp[3], envir = envir)
            if (exists("img.anat.sagit")) {tkrplot::tkrreplot(img.anat.sagit);tcltk::tkset(slider.anat.sagit,nn.anat.sagit)}
            if (exists("img.anat.coron")) {tkrplot::tkrreplot(img.anat.coron);tcltk::tkset(slider.anat.coron,nn.anat.coron)}
            if (exists("img.anat.axia")) {tkrplot::tkrreplot(img.anat.axia);tcltk::tkset(slider.anat.axia,nn.anat.axia)}

            ijk.anat <- c(nn.anat.sagit,nn.anat.coron,nn.anat.axia)
            xyz.anat <- ijk2xyz(ijk.anat,method=method,hdr.anat)$xyz
            tcltk::tclvalue(scanText.anat) <- paste("Scanner coordinates:",paste(round(xyz.anat,2),collapse=","))

          }
        }
      })
      slider.fonc.coron <- tcltk::tkscale(frame1.fonc, command=f.fonc.coron, from=as.numeric(tcltk::tclvalue(SliderCoron.fonc)), to=1, variable="nn.fonc.coron",showvalue=TRUE, resolution=1, orient="verti",label="Y")
      img.fonc.coron <- tkrplot::tkrplot(parent=frame1.fonc, fun=function() {
        oldpar <- par(mar=c(0,0,0,0), bg = "#555555")
    # coupe coronale
        image((1:dim.fonc.sagit)/abs(hdr.fonc$pixdim[2]),(1:dim.fonc.axia)/abs(hdr.fonc$pixdim[4]),as.matrix(vol.fonc[if (flip.fonc == -1) rev(1:dim.fonc.sagit) else 1:dim.fonc.sagit,nn.fonc.coron,,nn.fonc.time]),col=col.fonc,breaks=breaks.fonc,axes=FALSE,xlab="",ylab="",asp=dim.fonc.sagit/dim.fonc.axia)
        abline(h=nn.fonc.axia/abs(hdr.fonc$pixdim[4]),v=nn.fonc.sagit/abs(hdr.fonc$pixdim[2]),col="black")
        par(oldpar)
      }
                                , hscale=hscaletmp, vscale=vscaletmp)
      tcltk::tkbind(img.fonc.coron, "<Button-1>", function(x, y) {
#        asp <- 2
        wid.fonc <- as.integer(tcltk::tkwinfo("width", img.fonc.coron))
        hei.fonc <- as.integer(tcltk::tkwinfo("height", img.fonc.coron))

        y0 <- (hei.fonc - hei.fonc * abs(hdr.fonc$pixdim[2]) / abs(hdr.fonc$pixdim[4])) / 2

        if (as.numeric(y) >= y0 & as.numeric(y) <= (hei.fonc - y0)) {

          #if (as.numeric(y)>(hei.fonc/2 - dim.fonc.axia*wid.fonc/dim.fonc.sagit) & as.numeric(y)<(hei.fonc/2 + dim.fonc.axia*wid.fonc/dim.fonc.sagit)) {  
#          nn.fonc.sagit <<- ceiling(dim.fonc.sagit * as.numeric(x) /wid.fonc)
assign("nn.fonc.sagit", ceiling(dim.fonc.sagit * as.numeric(x) /wid.fonc), envir = envir)
          #          nn.fonc.axia <<- ceiling(dim.fonc.axia/2 + dim.fonc.sagit*(hei.fonc/2-as.numeric(y))/(wid.fonc*asp))


#        nn.fonc.axia <<- ceiling( dim.fonc.axia - dim.fonc.axia * (as.numeric(y) - y0) / (hei.fonc - 2 * y0) )
assign("nn.fonc.axia", ceiling( dim.fonc.axia - dim.fonc.axia * (as.numeric(y) - y0) / (hei.fonc - 2 * y0) ), envir = envir)
#        if (as.numeric(y) < y0) nn.fonc.axia <<- dim.fonc.axia
#        if (as.numeric(y) > (hei.fonc - y0)) nn.fonc.axia <<- 1


          
          tcltk::tkset(slider.fonc.sagit,nn.fonc.sagit)
          tcltk::tkset(slider.fonc.axia,nn.fonc.axia)
          tkrplot::tkrreplot(img.fonc.sagit)
          tkrplot::tkrreplot(img.fonc.coron)
          tkrplot::tkrreplot(img.fonc.axia)
          tkrplot::tkrreplot(img.fonc.palette)

          ijk.fonc <- c(nn.fonc.sagit,nn.fonc.coron,nn.fonc.axia)
          xyz.fonc <- ijk2xyz(ijk.fonc,method=method,hdr.fonc)$xyz
          tcltk::tclvalue(scanText.fonc) <- paste("Scanner coordinates:",paste(round(xyz.fonc,2),collapse=","))

          if (is.vol.anat) {
            tmp <- round(xyz2ijk(xyz.fonc,method=method,hdr.anat)$ijk)
#            nn.anat.sagit <<- tmp[1]
assign("nn.anat.sagit", tmp[1], envir = envir)
#            nn.anat.coron <<- tmp[2]
assign("nn.anat.coron", tmp[2], envir = envir)
#            nn.anat.axia <<- tmp[3]
assign("nn.anat.axia", tmp[3], envir = envir)
            if (exists("img.anat.sagit")) {tkrplot::tkrreplot(img.anat.sagit);tcltk::tkset(slider.anat.sagit,nn.anat.sagit)}
            if (exists("img.anat.coron")) {tkrplot::tkrreplot(img.anat.coron);tcltk::tkset(slider.anat.coron,nn.anat.coron)}
            if (exists("img.anat.axia")) {tkrplot::tkrreplot(img.anat.axia);tcltk::tkset(slider.anat.axia,nn.anat.axia)}

            ijk.anat <- c(nn.anat.sagit,nn.anat.coron,nn.anat.axia)
            xyz.anat <- ijk2xyz(ijk.anat,method=method,hdr.anat)$xyz
            tcltk::tclvalue(scanText.anat) <- paste("Scanner coordinates:",paste(round(xyz.anat,2),collapse=","))

          }
          
        }
      })

  
  # frame 2 to contain Axial image and Palette
      frame2.fonc <- tcltk::tkframe(tt.fonc, relief = "groove", borderwidth = 0, bg = "#555555")
      label.fonc.axia <- tcltk::tklabel(frame2.fonc,text="Axial ", bg = "#aaaaaa")  
      label.fonc.palette <- tcltk::tklabel(frame2.fonc,text="Palette values ", bg = "#aaaaaa")
      slider.fonc.axia <- tcltk::tkscale(frame2.fonc, command=f.fonc.axia, from=as.numeric(tcltk::tclvalue(SliderAxia.fonc)), to=1, variable="nn.fonc.axia",showvalue=TRUE, resolution=1, orient="verti",label="Z")
      img.fonc.axia <- tkrplot::tkrplot(parent=frame2.fonc, fun=function() {
        oldpar <- par(mar=c(0,0,0,0), bg = "#555555")
    # coupe axiale     
        image((1:dim.fonc.sagit)/abs(hdr.fonc$pixdim[2]),(1:dim.fonc.coron)/abs(hdr.fonc$pixdim[3]),as.matrix(vol.fonc[if (flip.fonc == -1) rev(1:dim.fonc.sagit) else 1:dim.fonc.sagit,,nn.fonc.axia,nn.fonc.time]),col=col.fonc,breaks=breaks.fonc,axes=FALSE,xlab="",ylab="",asp=dim.fonc.sagit/dim.fonc.coron)
#      image((1:dim.fonc.sagit)/abs(hdr.fonc$pixdim[2]),(1:dim.fonc.coron)/abs(hdr.fonc$pixdim[3]),as.matrix(vol.fonc[1:dim.fonc.sagit,,nn.fonc.axia,nn.fonc.time]),col=col.fonc,breaks=breaks.fonc,axes=FALSE,xlab="",ylab="",asp=dim.fonc.sagit/dim.fonc.coron)
        abline(h=nn.fonc.coron/abs(hdr.fonc$pixdim[3]),v=nn.fonc.sagit/abs(hdr.fonc$pixdim[2]),col="black")    
        par(oldpar)
      }
                               , hscale=hscaletmp, vscale=vscaletmp)
      tcltk::tkbind(img.fonc.axia, "<Button-1>", function(x, y) {
        wid.fonc <- as.integer(tcltk::tkwinfo("width", img.fonc.axia))
        hei.fonc <- as.integer(tcltk::tkwinfo("height", img.fonc.axia))

                y0 <- (hei.fonc - hei.fonc * abs(hdr.fonc$pixdim[2]) / abs(hdr.fonc$pixdim[3])) / 2

        if (as.numeric(y) >= y0 & as.numeric(y) <= (hei.fonc - y0)) {

#        nn.fonc.sagit <<- ceiling(dim.fonc.sagit * as.numeric(x) /wid.fonc)
assign("nn.fonc.sagit", ceiling(dim.fonc.sagit * as.numeric(x) /wid.fonc), envir = envir)
          #        nn.fonc.coron <<- ceiling(dim.fonc.coron - dim.fonc.coron * as.numeric(y) /hei.fonc)

#                  nn.fonc.coron <<- ceiling( dim.fonc.coron - dim.fonc.coron * (as.numeric(y) - y0) / (hei.fonc - 2 * y0) )
assign("nn.fonc.coron", ceiling( dim.fonc.coron - dim.fonc.coron * (as.numeric(y) - y0) / (hei.fonc - 2 * y0) ), envir = envir)

        tcltk::tkset(slider.fonc.sagit,nn.fonc.sagit)
        tcltk::tkset(slider.fonc.coron,nn.fonc.coron)
        tkrplot::tkrreplot(img.fonc.sagit)
        tkrplot::tkrreplot(img.fonc.coron)
        tkrplot::tkrreplot(img.fonc.axia)
        tkrplot::tkrreplot(img.fonc.palette)

        ijk.fonc <- c(nn.fonc.sagit,nn.fonc.coron,nn.fonc.axia)
        xyz.fonc <- ijk2xyz(ijk.fonc,method=method,hdr.fonc)$xyz
        tcltk::tclvalue(scanText.fonc) <- paste("Scanner coordinates:",paste(round(xyz.fonc,2),collapse=","))
 
        if (is.vol.anat) {
          tmp <- round(xyz2ijk(xyz.fonc,method=method,hdr.anat)$ijk)
#          nn.anat.sagit <<- tmp[1]
assign("nn.anat.sagit", tmp[1], envir = envir)
#          nn.anat.coron <<- tmp[2]
assign("nn.anat.coron", tmp[2], envir = envir)
#          nn.anat.axia <<- tmp[3]
assign("nn.anat.axia", tmp[3], envir = envir)
          if (exists("img.anat.sagit")) {tkrplot::tkrreplot(img.anat.sagit);tcltk::tkset(slider.anat.sagit,nn.anat.sagit)}
          if (exists("img.anat.coron")) {tkrplot::tkrreplot(img.anat.coron);tcltk::tkset(slider.anat.coron,nn.anat.coron)}
          if (exists("img.anat.axia")) {tkrplot::tkrreplot(img.anat.axia);tcltk::tkset(slider.anat.axia,nn.anat.axia)}

          ijk.anat <- c(nn.anat.sagit,nn.anat.coron,nn.anat.axia)
          xyz.anat <- ijk2xyz(ijk.anat,method=method,hdr.anat)$xyz
          tcltk::tclvalue(scanText.anat) <- paste("Scanner coordinates:",paste(round(xyz.anat,2),collapse=","))

        }

          }

      })
      img.fonc.palette <- tkrplot::tkrplot(parent=frame2.fonc, fun=function() {
        oldpar <- par(mfrow=c(2,1), bg = "#555555")
        nf.fonc <- layout(matrix(c(1,2), nrow=2, ncol=1, byrow = TRUE),respect = FALSE,widths=c(0.8,0.8),height=c(0.3,0.8))
        par(mar=c(5.1,4.1,4.1,2.1), mai=c(0.5,0.82,0.2,0.42), bg = "#555555")
        maColorBar(x=seq(from=mini.fonc,to=maxi.fonc,len=length(col.fonc)+1),col=col.fonc,horizontal=TRUE)
        par(mar=c(1.1,2.1,2.1,0.1), mai=c(0.5,0.42,0.4,0.22))
        plot(vol.fonc[nn.fonc.sagit,nn.fonc.coron,nn.fonc.axia,],type="l",main=paste("Time course of the selected voxel.\nValue at that time: ",round(vol.fonc[nn.fonc.sagit,nn.fonc.coron,nn.fonc.axia,nn.fonc.time],4),sep=""),xlab="",ylab="",cex.main=0.8)
        points(nn.fonc.time,vol.fonc[nn.fonc.sagit,nn.fonc.coron,nn.fonc.axia,nn.fonc.time],col="blue",pch=1,cex=1.2)
        par(oldpar)
      }
                                  , hscale=hscaletmp, vscale=vscaletmp)
    
 
  # frame 3 to contain time slider and Quit button
      frame3.fonc <- tcltk::tkframe(tt.fonc, relief = "groove", borderwidth = 2, bg = "#555555")
      neuro.fonc <- tcltk::tklabel(frame3.fonc,text="Neurological display")
      timenb.fonc <- tcltk::tklabel(frame3.fonc,text="Time", bg = "#aaaaaa")
      slider.fonc.time <- tcltk::tkscale(frame3.fonc, command=f.fonc.time, from=1, to=as.numeric(tcltk::tclvalue(SliderTime.fonc)), variable="nn.fonc.time",showvalue=TRUE, resolution=1,bigincrement=1,sliderlength=10,digits=0,length=150, orient="horiz")
      coord.fonc <- tcltk::tklabel(frame3.fonc,text=tcltk::tclvalue(scanText.fonc),justify="left")
      OK.but.fonc <- tcltk::tkbutton(frame3.fonc,text="Quit",command=OnOK.fonc, bg = "#aaaaaa")
  
  
# We build the tk window with its widgets
      tcltk::tkgrid(tcltk::tklabel(frame1.fonc,text="             ", bg = "#555555"),label.fonc.coron,tcltk::tklabel(frame1.fonc,text="             ", bg = "#555555"),label.fonc.sagit ,padx = 1, pady = 1)
      tcltk::tkgrid(slider.fonc.sagit,img.fonc.coron,slider.fonc.coron,img.fonc.sagit ,padx = 1, pady = 1)
      tcltk::tkgrid(frame1.fonc)
      tcltk::tkgrid(tcltk::tklabel(frame2.fonc,text="             ", bg = "#555555"),label.fonc.axia,tcltk::tklabel(frame2.fonc,text="             ", bg = "#555555"),label.fonc.palette ,padx = 1, pady = 1)
      tcltk::tkgrid(slider.fonc.axia,img.fonc.axia,tcltk::tklabel(frame2.fonc,text="             ", bg = "#555555"), img.fonc.palette ,padx = 1, pady = 1)
      tcltk::tkgrid(frame2.fonc)
      tcltk::tkconfigure(coord.fonc,textvariable=scanText.fonc,width=35,relief="solid")
      tcltk::tkgrid(neuro.fonc,timenb.fonc,slider.fonc.time,OK.but.fonc,coord.fonc, padx = 10, pady = 10)
      tcltk::tkgrid(frame3.fonc, sticky = "ew")
        
      if (is.time.series) {
        if (exists(time.series)) time.series <- get(time.series)
        if (is.character(time.series)) { # reading of the image
          time.series <- as.matrix(read.table(time.series,header=TRUE))
        } else {
          time.series <- as.matrix(time.series)
        }
      
        tt.fonc.time.series <- tcltk::tktoplevel(bg="#555555")
        tcltk::tkwm.title(tt.fonc.time.series, "Associated time course")
      
        img.time.series <- tkrplot::tkrplot(parent=tt.fonc.time.series, fun=function() {
          oldpar <- par(mar=c(2,2,2,2), bg = "#555555")
          if (dim(time.series)[1] > dim(time.series)[2]) {
            plot(time.series[,nn.fonc.time],type="l",main=paste("Component number ",nn.fonc.time,sep=""))
          } else {
            plot(time.series[nn.fonc.time,],type="l",main=paste("Component number ",nn.fonc.time,sep=""))
          }
          par(oldpar)
        }
                                   , hscale=1.5, vscale=0.5)                   
        
        tcltk::tkgrid(img.time.series) 
      }
      
    } # Fin de if (is.vol.fonc)
    

    if (is.vol.anat) {

# Useful functions
      f.anat.sagit <- function(...) {
        n.anat.sagit <- as.numeric(tcltk::tclvalue("nn.anat.sagit"))
        if (n.anat.sagit != nn.anat.sagit) {
#          nn.anat.sagit <<- n.anat.sagit
assign("nn.anat.sagit", n.anat.sagit, envir = envir)
          tkrplot::tkrreplot(img.anat.sagit)
          tkrplot::tkrreplot(img.anat.coron)
          tkrplot::tkrreplot(img.anat.axia)

          ijk.anat <- c(nn.anat.sagit,nn.anat.coron,nn.anat.axia)
          xyz.anat <- ijk2xyz(ijk.anat,method=method,hdr.anat)$xyz
          tcltk::tclvalue(scanText.anat) <- paste("Scanner coordinates:",paste(round(xyz.anat,2),collapse=","))

        }
      }
    
      f.anat.coron <- function(...) {
        n.anat.coron <- as.numeric(tcltk::tclvalue("nn.anat.coron"))
        if (n.anat.coron != nn.anat.coron) {
#          nn.anat.coron <<- n.anat.coron
assign("nn.anat.coron", n.anat.coron, envir = envir)
          tkrplot::tkrreplot(img.anat.sagit)
          tkrplot::tkrreplot(img.anat.coron)
          tkrplot::tkrreplot(img.anat.axia)

          ijk.anat <- c(nn.anat.sagit,nn.anat.coron,nn.anat.axia)
          xyz.anat <- ijk2xyz(ijk.anat,method=method,hdr.anat)$xyz
          tcltk::tclvalue(scanText.anat) <- paste("Scanner coordinates:",paste(round(xyz.anat,2),collapse=","))

        }
      }
    
    
      f.anat.axia <- function(...) {
        n.anat.axia <- as.numeric(tcltk::tclvalue("nn.anat.axia"))
        if (n.anat.axia != nn.anat.axia) {
#          nn.anat.axia <<- n.anat.axia
assign("nn.anat.axia", n.anat.axia, envir = envir)
          tkrplot::tkrreplot(img.anat.sagit)
          tkrplot::tkrreplot(img.anat.coron)
          tkrplot::tkrreplot(img.anat.axia)

          ijk.anat <- c(nn.anat.sagit,nn.anat.coron,nn.anat.axia)
          xyz.anat <- ijk2xyz(ijk.anat,method=method,hdr.anat)$xyz
          tcltk::tclvalue(scanText.anat) <- paste("Scanner coordinates:",paste(round(xyz.anat,2),collapse=","))
     
        }
      }
    
    
      OnOK.anat <- function() {tcltk::tkdestroy(tt.anat)}
 

  #set up base GUI window
      if(.Platform$OS.type == "windows") flush.console()
    
      tt.anat <- tcltk::tktoplevel(bg="#555555")

      tcltk::tkwm.title(tt.anat, my.title.anat)
      

  # frame 1 to contain images
      frame1.anat <- tcltk::tkframe(tt.anat, relief = "groove", borderwidth = 0, bg = "#555555")
      label.anat.sagit <- tcltk::tklabel(frame1.anat,text="Sagittal ", bg = "#aaaaaa")
      label.anat.coron <- tcltk::tklabel(frame1.anat,text="Coronal ", bg = "#aaaaaa")
      slider.anat.sagit <- tcltk::tkscale(frame1.anat, command=f.anat.sagit, from=as.numeric(tcltk::tclvalue(SliderSagit.anat)), to=1, variable="nn.anat.sagit",showvalue=TRUE, resolution=1, orient="verti",label="X") 
      img.anat.sagit <- tkrplot::tkrplot(parent=frame1.anat, fun=function() {
        oldpar <- par(mar=c(0,0,0,0), bg = "#555555")
    # coupe sagittale
        image((1:dim.anat.coron)/abs(hdr.anat$pixdim[3]),(1:dim.anat.axia)/abs(hdr.anat$pixdim[4]),as.matrix(vol.anat[if (flip.anat == -1) dim.anat.sagit-nn.anat.sagit+1 else nn.anat.sagit,,]),col=col.anat,breaks=breaks.anat,axes=FALSE,xlab="",ylab="",asp=dim.anat.coron/dim.anat.axia)
        abline(h=nn.anat.axia/abs(hdr.anat$pixdim[4]),v=nn.anat.coron/abs(hdr.anat$pixdim[3]),col="red")
        par(oldpar)
      }
                                , hscale=hscaletmp, vscale=vscaletmp)
      tcltk::tkbind(img.anat.sagit, "<Button-1>", function(x, y) {
        wid.anat <- as.integer(tcltk::tkwinfo("width", img.anat.sagit))
        hei.anat <- as.integer(tcltk::tkwinfo("height", img.anat.sagit))

        y0 <- (hei.anat - hei.anat * abs(hdr.anat$pixdim[3]) / abs(hdr.anat$pixdim[4])) / 2
        if (as.numeric(y) >= y0 & as.numeric(y) <= (hei.anat - y0)) {

        
#        nn.anat.coron <<- ceiling(dim.anat.coron * as.numeric(x) /wid.anat)
assign("nn.anat.coron", ceiling(dim.anat.coron * as.numeric(x) /wid.anat), envir = envir)
#        nn.anat.axia <<- ceiling( dim.anat.axia - dim.anat.axia * as.numeric(y) /hei.anat )


#        nn.anat.axia <<- ceiling( dim.anat.axia - dim.anat.axia * (as.numeric(y) - y0) / (hei.anat - 2 * y0) )
assign("nn.anat.axia", ceiling( dim.anat.axia - dim.anat.axia * (as.numeric(y) - y0) / (hei.anat - 2 * y0) ), envir = envir)
#        if (as.numeric(y) < y0) nn.anat.axia <<- dim.anat.axia
#        if (as.numeric(y) > (hei.anat - y0)) nn.anat.axia <<- 1




        tcltk::tkset(slider.anat.coron,nn.anat.coron)	
        tcltk::tkset(slider.anat.axia,nn.anat.axia)
        tkrplot::tkrreplot(img.anat.sagit)
        tkrplot::tkrreplot(img.anat.coron)
        tkrplot::tkrreplot(img.anat.axia)

        ijk.anat <- c(nn.anat.sagit,nn.anat.coron,nn.anat.axia)
        xyz.anat <- ijk2xyz(ijk.anat,method=method,hdr.anat)$xyz
        tcltk::tclvalue(scanText.anat) <- paste("Scanner coordinates:",paste(round(xyz.anat,2),collapse=","))



        if (is.vol.fonc) {
          tmp <- round(xyz2ijk(xyz.anat,method=method,hdr.fonc)$ijk)
#          nn.fonc.sagit <<- tmp[1]
assign("nn.fonc.sagit", tmp[1], envir = envir)
#          nn.fonc.coron <<- tmp[2]
assign("nn.fonc.coron", tmp[2], envir = envir)
#          nn.fonc.axia <<- tmp[3]
assign("nn.fonc.axia", tmp[3], envir = envir)
          if ((1 <= nn.fonc.sagit) & (nn.fonc.sagit <= dim.fonc.sagit) &(1 <= nn.fonc.coron) & (nn.fonc.coron <= dim.fonc.coron) & (1 <= nn.fonc.axia) & (nn.fonc.axia <= dim.fonc.axia)) {
            tkrplot::tkrreplot(img.fonc.sagit)
            tkrplot::tkrreplot(img.fonc.coron)
            tkrplot::tkrreplot(img.fonc.axia)
            tkrplot::tkrreplot(img.fonc.palette)
            tcltk::tkset(slider.fonc.sagit,nn.fonc.sagit)
            tcltk::tkset(slider.fonc.coron,nn.fonc.coron)
            tcltk::tkset(slider.fonc.axia,nn.fonc.axia)

            ijk.fonc <- c(nn.fonc.sagit,nn.fonc.coron,nn.fonc.axia)
            xyz.fonc <- ijk2xyz(ijk.fonc,method=method,hdr.fonc)$xyz
            tcltk::tclvalue(scanText.fonc) <- paste("Scanner coordinates:",paste(round(xyz.fonc,2),collapse=","))

          }
        }
          }

      })
      slider.anat.coron <- tcltk::tkscale(frame1.anat, command=f.anat.coron, from=as.numeric(tcltk::tclvalue(SliderCoron.anat)), to=1, variable="nn.anat.coron",showvalue=TRUE, resolution=1, orient="verti",label="Y")
      img.anat.coron <- tkrplot::tkrplot(parent=frame1.anat, fun=function() {
        oldpar <- par(mar=c(0,0,0,0), bg = "#555555")
    # coupe coronale
        image((1:dim.anat.sagit)/abs(hdr.anat$pixdim[2]),(1:dim.anat.axia)/abs(hdr.anat$pixdim[4]),as.matrix(vol.anat[if (flip.anat == -1) rev(1:dim.anat.sagit) else 1:dim.anat.sagit,nn.anat.coron,]),col=col.anat,breaks=breaks.anat,axes=FALSE,xlab="",ylab="",asp=dim.anat.sagit/dim.anat.axia)
        abline(h=nn.anat.axia/abs(hdr.anat$pixdim[4]),v=nn.anat.sagit/abs(hdr.anat$pixdim[2]),col="red")
        par(oldpar)
      }
                                , hscale=hscaletmp, vscale=vscaletmp)
      tcltk::tkbind(img.anat.coron, "<Button-1>", function(x, y) {
        wid.anat <- as.integer(tcltk::tkwinfo("width", img.anat.coron))
        hei.anat <- as.integer(tcltk::tkwinfo("height", img.anat.coron))


        y0 <- (hei.anat - hei.anat * abs(hdr.anat$pixdim[2]) / abs(hdr.anat$pixdim[4])) / 2
        if (as.numeric(y) >= y0 & as.numeric(y) <= (hei.anat - y0)) {

#        nn.anat.sagit <<- ceiling(dim.anat.sagit * as.numeric(x) /wid.anat)
assign("nn.anat.sagit", ceiling(dim.anat.sagit * as.numeric(x) /wid.anat), envir = envir)
#        nn.anat.axia <<- ceiling( dim.anat.axia - dim.anat.axia * as.numeric(y) /hei.anat )


#        nn.anat.axia <<- ceiling( dim.anat.axia - dim.anat.axia * (as.numeric(y) - y0) / (hei.anat - 2 * y0) )
assign("nn.anat.axia", ceiling( dim.anat.axia - dim.anat.axia * (as.numeric(y) - y0) / (hei.anat - 2 * y0) ), envir = envir)
#        if (as.numeric(y) < y0) nn.anat.axia <<- dim.anat.axia
#        if (as.numeric(y) > (hei.anat - y0)) nn.anat.axia <<- 1



        
        tcltk::tkset(slider.anat.sagit,nn.anat.sagit)
        tcltk::tkset(slider.anat.axia,nn.anat.axia)
        tkrplot::tkrreplot(img.anat.sagit)
        tkrplot::tkrreplot(img.anat.coron)
        tkrplot::tkrreplot(img.anat.axia)

        ijk.anat <- c(nn.anat.sagit,nn.anat.coron,nn.anat.axia)
        xyz.anat <- ijk2xyz(ijk.anat,method=method,hdr.anat)$xyz
        tcltk::tclvalue(scanText.anat) <- paste("Scanner coordinates:",paste(round(xyz.anat,2),collapse=","))

        if (is.vol.fonc) {
          tmp <- round(xyz2ijk(xyz.anat,method=method,hdr.fonc)$ijk)
#          nn.fonc.sagit <<- tmp[1]
assign("nn.fonc.sagit", tmp[1], envir = envir)
#          nn.fonc.coron <<- tmp[2]
assign("nn.fonc.coron", tmp[2], envir = envir)
#          nn.fonc.axia <<- tmp[3]
assign("nn.fonc.axia", tmp[3], envir = envir)
          if ((1 <= nn.fonc.sagit) & (nn.fonc.sagit <= dim.fonc.sagit) &(1 <= nn.fonc.coron) & (nn.fonc.coron <= dim.fonc.coron) & (1 <= nn.fonc.axia) & (nn.fonc.axia <= dim.fonc.axia)) {
            tkrplot::tkrreplot(img.fonc.sagit)
            tkrplot::tkrreplot(img.fonc.coron)
            tkrplot::tkrreplot(img.fonc.axia)
            tkrplot::tkrreplot(img.fonc.palette)
            tcltk::tkset(slider.fonc.sagit,nn.fonc.sagit)
            tcltk::tkset(slider.fonc.coron,nn.fonc.coron)
            tcltk::tkset(slider.fonc.axia,nn.fonc.axia)

            ijk.fonc <- c(nn.fonc.sagit,nn.fonc.coron,nn.fonc.axia)
            xyz.fonc <- ijk2xyz(ijk.fonc,method=method,hdr.fonc)$xyz
            tcltk::tclvalue(scanText.fonc) <- paste("Scanner coordinates:",paste(round(xyz.fonc,2),collapse=","))

          }
          }
        }     
      })

  
  # frame 2 to contain Axial image and Palette
      frame2.anat <- tcltk::tkframe(tt.anat, relief = "groove", borderwidth = 0, bg = "#555555")
      label.anat.axia <- tcltk::tklabel(frame2.anat,text="Axial ", bg = "#aaaaaa")  
      label.anat.palette <- tcltk::tklabel(frame2.anat,text="Palette values ", bg = "#aaaaaa")
      slider.anat.axia <- tcltk::tkscale(frame2.anat, command=f.anat.axia, from=as.numeric(tcltk::tclvalue(SliderAxia.anat)), to=1, variable="nn.anat.axia",showvalue=TRUE, resolution=1, orient="verti",label="Z")
      img.anat.axia <- tkrplot::tkrplot(parent=frame2.anat, fun=function() {
        oldpar <- par(mar=c(0,0,0,0), bg = "#555555")
    # coupe axiale     
        image((1:dim.anat.sagit)/abs(hdr.anat$pixdim[2]),(1:dim.anat.coron)/abs(hdr.anat$pixdim[3]),as.matrix(vol.anat[if (flip.anat == -1) rev(1:dim.anat.sagit) else 1:dim.anat.sagit,,nn.anat.axia]),col=col.anat,breaks=breaks.anat,axes=FALSE,xlab="",ylab="",asp=dim.anat.sagit/dim.anat.coron)
        abline(h=nn.anat.coron/abs(hdr.anat$pixdim[3]),v=nn.anat.sagit/abs(hdr.anat$pixdim[2]),col="red")    
        par(oldpar)
      }
                               , hscale=hscaletmp, vscale=vscaletmp)
      tcltk::tkbind(img.anat.axia, "<Button-1>", function(x, y) {
        wid.anat <- as.integer(tcltk::tkwinfo("width", img.anat.axia))
        hei.anat <- as.integer(tcltk::tkwinfo("height", img.anat.axia))

        y0 <- (hei.anat - hei.anat * abs(hdr.anat$pixdim[2]) / abs(hdr.anat$pixdim[3])) / 2
        if (as.numeric(y) >= y0 & as.numeric(y) <= (hei.anat - y0)) {

        
#        nn.anat.sagit <<- ceiling(dim.anat.sagit * as.numeric(x) /wid.anat)
assign("nn.anat.sagit", ceiling(dim.anat.sagit * as.numeric(x) /wid.anat), envir = envir)
          #        nn.anat.coron <<- ceiling(dim.anat.coron - dim.anat.coron * as.numeric(y) /hei.anat)

#        nn.anat.coron <<- ceiling( dim.anat.coron - dim.anat.coron * (as.numeric(y) - y0) / (hei.anat - 2 * y0) )
assign("nn.anat.coron", ceiling( dim.anat.coron - dim.anat.coron * (as.numeric(y) - y0) / (hei.anat - 2 * y0) ), envir = envir)

          
        tcltk::tkset(slider.anat.sagit,nn.anat.sagit)
        tcltk::tkset(slider.anat.coron,nn.anat.coron)
        tkrplot::tkrreplot(img.anat.sagit)
        tkrplot::tkrreplot(img.anat.coron)
        tkrplot::tkrreplot(img.anat.axia)

        ijk.anat <- c(nn.anat.sagit,nn.anat.coron,nn.anat.axia)
        xyz.anat <- ijk2xyz(ijk.anat,method=method,hdr.anat)$xyz
        tcltk::tclvalue(scanText.anat) <- paste("Scanner coordinates:",paste(round(xyz.anat,2),collapse=","))
        
        if (is.vol.fonc) {
          tmp <- round(xyz2ijk(xyz.anat,method=method,hdr.fonc)$ijk)
#          nn.fonc.sagit <<- tmp[1]
assign("nn.fonc.sagit", tmp[1], envir = envir)
#          nn.fonc.coron <<- tmp[2]
assign("nn.fonc.coron", tmp[2], envir = envir)
#          nn.fonc.axia <<- tmp[3]
assign("nn.fonc.axia", tmp[3], envir = envir)
          if ((1 <= nn.fonc.sagit) & (nn.fonc.sagit <= dim.fonc.sagit) &(1 <= nn.fonc.coron) & (nn.fonc.coron <= dim.fonc.coron) & (1 <= nn.fonc.axia) & (nn.fonc.axia <= dim.fonc.axia)) {
            tkrplot::tkrreplot(img.fonc.sagit)
            tkrplot::tkrreplot(img.fonc.coron)
            tkrplot::tkrreplot(img.fonc.axia)
            tkrplot::tkrreplot(img.fonc.palette)
            tcltk::tkset(slider.fonc.sagit,nn.fonc.sagit)
            tcltk::tkset(slider.fonc.coron,nn.fonc.coron)
            tcltk::tkset(slider.fonc.axia,nn.fonc.axia)

            ijk.fonc <- c(nn.fonc.sagit,nn.fonc.coron,nn.fonc.axia)
            xyz.fonc <- ijk2xyz(ijk.fonc,method=method,hdr.fonc)$xyz
            tcltk::tclvalue(scanText.fonc) <- paste("Scanner coordinates:",paste(round(xyz.fonc,2),collapse=","))

          }
        }
          }
      })
      img.anat.palette <- tkrplot::tkrplot(parent=frame2.anat, fun=function() {
        nf.anat <- layout(matrix(c(0,1,0), 1, 3, byrow = TRUE),respect = FALSE,widths=c(4,1,4),height=0.8)
        oldpar <- par(mar=c(0.4,0.1,0.4,0.1), bg = "#555555")
        maColorBar(x=seq(from=mini.anat,to=maxi.anat,len=length(col.anat)+1),col=col.anat,horizontal=FALSE)
        par(oldpar)
      }
                                  , hscale=hscaletmp, vscale=vscaletmp)
  
 
  # frame 3 to contain Quit button
      frame3.anat <- tcltk::tkframe(tt.anat, relief = "groove", borderwidth = 2, bg = "#555555") 
      neuro.anat <- tcltk::tklabel(frame3.anat,text="Neurological display")
      coord.anat <- tcltk::tklabel(frame3.anat,text=tcltk::tclvalue(scanText.anat))
      Quit.but.anat <- tcltk::tkbutton(frame3.anat,text="Quit",command=OnOK.anat, bg = "#aaaaaa")
  
# We build the tk window with its widgets
      tcltk::tkgrid(tcltk::tklabel(frame1.anat,text="             ", bg = "#555555"),label.anat.coron,tcltk::tklabel(frame1.anat,text="             ", bg = "#555555"),label.anat.sagit ,padx = 1, pady = 1)
      tcltk::tkgrid(slider.anat.sagit,img.anat.coron,slider.anat.coron,img.anat.sagit ,padx = 1, pady = 1)
      tcltk::tkgrid(frame1.anat)
      tcltk::tkgrid(tcltk::tklabel(frame2.anat,text="             ", bg = "#555555"),label.anat.axia,tcltk::tklabel(frame2.anat,text="             ", bg = "#555555"),label.anat.palette ,padx = 1, pady = 1)
      tcltk::tkgrid(slider.anat.axia,img.anat.axia,tcltk::tklabel(frame2.anat,text="             ", bg = "#555555"), img.anat.palette ,padx = 1, pady = 1)
      tcltk::tkgrid(frame2.anat)
      tcltk::tkconfigure(coord.anat,textvariable=scanText.anat) ###### ICI
      tcltk::tkgrid(neuro.anat,Quit.but.anat, coord.anat, padx = 10, pady = 10)
      tcltk::tkgrid(frame3.anat, sticky = "ew")   

    } # Fin de if (is.vol.anat)
    
  } # Fin de plot.volume()

  

  gui.end <- function(...){
    tcltk::tkdestroy(base.plot)
  }

    ##set tcl variables
  file.name.fonc <- tcltk::tclVar() ; if (!is.null(array.fonc)) tcltk::tclvalue(file.name.fonc) <- array.fonc
  file.name.anat <- tcltk::tclVar()
  file.name.time.series <- tcltk::tclVar()

   
    #set up base GUI window
  if(.Platform$OS.type == "windows") flush.console()
    
  base.plot <- tcltk::tktoplevel(bg="#555555")
  tcltk::tkwm.title(base.plot, "(F)MRI visualization")
    
    
    #frame to contain file selection
  frame1 <- tcltk::tkframe(base.plot, relief = "groove", borderwidth = 2, bg = "#555555")
    
  file.fonc.entry <- tcltk::tkentry(frame1, textvariable = file.name.fonc, width = 50, bg = "#ffffff")
  file.fonc.find.but <- tcltk::tkbutton(frame1, text = "Select functionnal NIFTI file (or give R object name)", width = 50, command = gui.file.fonc, bg = "#aaaaaa", anchor = "c")
  tcltk::tkgrid(file.fonc.find.but, file.fonc.entry, pady = 10, padx = 10)
  
  file.time.series.entry <- tcltk::tkentry(frame1, textvariable = file.name.time.series, width = 50, bg = "#ffffff")
  file.time.series.find.but <- tcltk::tkbutton(frame1, text = "Select time series component file (or give R object name)", width = 50, command = gui.file.time.series, bg = "#aaaaaa", anchor = "c")
  tcltk::tkgrid(file.time.series.find.but, file.time.series.entry, pady = 10, padx = 10)
  
  file.anat.entry <- tcltk::tkentry(frame1, textvariable = file.name.anat, width = 50, bg = "#ffffff")
  file.anat.find.but <- tcltk::tkbutton(frame1, text = "Select anatomical NIFTI file (or give R object name)", width = 50, command = gui.file.anat, bg = "#aaaaaa", anchor = "c")
  tcltk::tkgrid(file.anat.find.but, file.anat.entry, pady = 10, padx = 10)
    
  tcltk::tkgrid(frame1)
    
  hscaletmp <- tcltk::tclVar(0.6)
  vscaletmp <- tcltk::tclVar(0.6)
  
    #frame for start and end buttons     
  frame2 <- tcltk::tkframe(base.plot, borderwidth = 2, bg = "#555555")
  go.but <- tcltk::tkbutton(frame2, text = "Start", bg = "#aaaaaa", command = function() plot.volume(envir = gui_env))
  q.but <- tcltk::tkbutton(frame2, text = "Quit",command = gui.end, bg = "#aaaaaa")
  
  hscale.txt <- tcltk::tklabel(frame2,text="hscale factor", bg = "#aaaaaa")
  hscale.entry <- tcltk::tkentry(frame2, textvariable = hscaletmp, width = 5, bg = "#ffffff")
  vscale.txt <- tcltk::tklabel(frame2,text="vscale factor", bg = "#aaaaaa")
  vscale.entry <- tcltk::tkentry(frame2, textvariable = vscaletmp, width = 5, bg = "#ffffff")


  tcltk::tkgrid(go.but, q.but, hscale.txt,hscale.entry, vscale.txt,vscale.entry, padx = 30, pady = 20)
  tcltk::tkgrid(frame2)

#require(tcltk) || stop("tcltk support is absent")

local({

    gui.env <- environment()  # capture this local environment
    
    gui.file<-function(){
        tcltk::tclvalue(file.name) <- tcltk::tcl("tk_getOpenFile")   }
    
    
    gui.mask<-function(){
        tcltk::tclvalue(mask) <- tcltk::tcl("tk_getOpenFile")  }
    
    gui.save<-function(...){
        assign(tcltk::tclvalue(save.r), tmp.ica.obj, envir = .GlobalEnv)
    }
    
    
    
    
    gui.ica<-function(...){
        
        if(tcltk::tclvalue(mask) == "" && tcltk::tclvalue(create.mask) == 0){
            err1 <- tcltk::tktoplevel()
            err1.f1 <- tcltk::tkframe(err1, relief="groove", borderwidth = 2)
            err1.label <- tcltk::tklabel(err1.f1, text = "Either select a mask file or select create mask", bg = "#aaaaaa", pady = 20, padx = 20)
            tcltk::tkgrid(err1.label)
            tcltk::tkgrid(err1.f1)
            return()
        }
        
        if(tcltk::tclvalue(mask) != "" && tcltk::tclvalue(create.mask) == 0) msk <- tcltk::tclvalue(mask)
        if(tcltk::tclvalue(mask) == "" && tcltk::tclvalue(create.mask) == 1) msk <- NULL
        v.norm <- 1
        if(tcltk::tclvalue(var.norm) == 0) v.norm <- 0
        sl <- NULL
        if(tcltk::tclvalue(slices) == 0) sl <- "all"
        
        gui.env$tmp.ica.obj <- f.ica.fmri(tcltk::tclvalue(file.name),
                                   n.comp = as.numeric(tcltk::tclvalue(n.comp)),
                                   norm.col = v.norm,
                                   fun = "logcosh",
                                   maxit = 100,
                                   alg.type = "parallel",
                                   alpha = 1,
                                   tol = 0.0001,
                                   mask.file.name = msk,
                                   sl)
        
        print("done")
        
    }
    
    gui.jpeg<-function(...){  
        f.plot.ica.fmri.jpg(tmp.ica.obj, tcltk::tclvalue(jpeg), width = 700, height = 700)}
    
    gui.end<-function(...){
        #rm(tmp.ica.obj, envir = .GlobalEnv)
        tcltk::tkdestroy(base.ica)
    }
    gui.plot.ica<-function(...){  
        f.plot.ica.fmri(tmp.ica.obj, as.numeric(tcltk::tclvalue(comp)))}
    
    ##set tcl variables
    file.name <- tcltk::tclVar()
    mask <- tcltk::tclVar()
    n.comp <- tcltk::tclVar("30")
    var.norm <- tcltk::tclVar("0")
    slices <- tcltk::tclVar("0")
    create.mask <- tcltk::tclVar("0")
    save.r <- tcltk::tclVar()
    jpeg <- tcltk::tclVar()
    comp <- tcltk::tclVar()
    
    #set up base GUI window
    if(.Platform$OS.type == "windows") flush.console()
    
    base.ica <- tcltk::tktoplevel(bg="#555555")
    tcltk::tkwm.title(base.ica, "Spatial ICA for fMRI datasets")
    
    
    #frame to contain file selection
    ica.f1 <- tcltk::tkframe(base.ica, relief = "groove", borderwidth = 2, bg = "#555555")
    
    ica.file.entry <- tcltk::tkentry(ica.f1, textvariable = file.name, width = 50, bg = "#ffffff")
    ica.file.find.but <- tcltk::tkbutton(ica.f1, text = "Select File", width = 15, command = gui.file, bg = "#aaaaaa", anchor = "c")
    tcltk::tkgrid(ica.file.find.but, ica.file.entry, pady = 10, padx = 10)
    
    ica.mask.entry <- tcltk::tkentry(ica.f1, textvariable = mask, width = 50, bg = "#ffffff")
    ica.mask.find.but <- tcltk::tkbutton(ica.f1, text = "Select Mask File", width = 15, command = gui.mask, bg = "#aaaaaa")
    
    tcltk::tkgrid(ica.mask.find.but, ica.mask.entry, padx = 10, pady = 10)
    tcltk::tkgrid(ica.f1)
    
    #frame for number of components       
    ica.f2 <- tcltk::tkframe(base.ica, relief = "groove", borderwidth = 2, bg = "#555555")
    
    ica.n.comp.label <- tcltk::tklabel(ica.f2, text = "Number of components to extract", bg = "#aaaaaa")      
    ica.n.comp.entry <- tcltk::tkentry(ica.f2, textvariable = n.comp, width = 5, bg = "#ffffff")
    tcltk::tkgrid(ica.n.comp.label, ica.n.comp.entry, padx = 10, pady = 10)
    
    tcltk::tkgrid(ica.f2, sticky = "ew")
    
    
    
    #frame for options
    ica.f3 <- tcltk::tkframe(base.ica, relief = "groove", borderwidth = 2, bg = "#555555")
    
    ica.normalise.but <- tcltk::tkcheckbutton(ica.f3, text = "Variance Normalize", bg = "#aaaaaa", variable = var.norm) 
    ica.slices.but <- tcltk::tkcheckbutton(ica.f3, text = "Exclude top/bottom slices", bg = "#aaaaaa", variable = slices) 
    ica.create.mask.but <- tcltk::tkcheckbutton(ica.f3, text = "Create Mask", bg = "#aaaaaa", variable = create.mask)
    tcltk::tkgrid(ica.normalise.but, ica.slices.but, ica.create.mask.but, padx = 30, pady = 10)
    
    tcltk::tkgrid(ica.f3, sticky = "ew")
    
    #frame for saving object to R session
    ica.f4 <- tcltk::tkframe(base.ica, relief = "groove", borderwidth = 2, bg = "#555555")
    
#    ica.save.entry <- tcltk::tkentry(ica.f4, textvariable = save.r, width = 40, bg = "#ffffff")
#    ica.save.but <- tcltk::tkbutton(ica.f4, text = "Save to R object", width = 15, command = gui.save, bg = "#aaaaaa")
#    tcltk::tkgrid(ica.save.but, ica.save.entry, padx = 10, pady = 10)
    
    tcltk::tkgrid(ica.f4,sticky = "ew")
    
    #frame for plotting components to jpeg files
    ica.f5 <- tcltk::tkframe(base.ica, relief = "groove", borderwidth = 2, bg = "#555555")
    
    ica.jpeg.entry <- tcltk::tkentry(ica.f5, textvariable = jpeg, width = 40, bg = "#ffffff")
    ica.jpeg.but <- tcltk::tkbutton(ica.f5, text = "Save to jpeg files", width = 15, command = gui.jpeg, bg = "#aaaaaa")
    tcltk::tkgrid(ica.jpeg.but, ica.jpeg.entry, padx = 10, pady = 10)
    
    tcltk::tkgrid(ica.f5, sticky = "ew")
    
    
    #frame for plotting components
    ica.f6 <- tcltk::tkframe(base.ica, relief = "groove", borderwidth = 2, bg = "#555555")
    
    ica.plot.entry <- tcltk::tkentry(ica.f6, textvariable = comp, width = 5, bg = "#ffffff")
    ica.plot.but <- tcltk::tkbutton(ica.f6, text = "Plot component", width = 15, command = gui.plot.ica, bg = "#aaaaaa")
    tcltk::tkgrid(ica.plot.but, ica.plot.entry, padx = 10, pady = 10)
    
    tcltk::tkgrid(ica.f6, sticky = "ew")
    
    #frame for start and end buttons     
    fr3 <- tcltk::tkframe(base.ica, borderwidth = 2, bg = "#555555")
    go.but<- tcltk::tkbutton(fr3, text = "Start", bg = "#aaaaaa", command = gui.ica)
    q.but <- tcltk::tkbutton(fr3, text = "Quit",
                      command = gui.end, bg = "#aaaaaa")
    tcltk::tkgrid(go.but, q.but, padx = 30, pady = 20)
    tcltk::tkgrid(fr3)

     tcltk::tkwait.window(base.ica)
})

#f.gaussian.spatial.smoothing.functions.R

#examples of 3 different kernels 
a <- GaussSmoothKernel(voxdim = c(1, 1, 1), ksize = 5, sigma = diag(1, 3))
##f.grid(1,5)

oldpar <- par(mfrow = c(1, 5))
for(i in 1:5){
    image(a[i, , ], zlim = c(min(a), max(a)),axes = FALSE)
    box()
}

a <- GaussSmoothKernel(voxdim = c(1, 1, 1), ksize = 5, sigma = diag(c(0, 2, 2)))
##f.grid(1,5)
par(mfrow = c(1, 5))
for(i in 1:5){
    image(a[i, , ], zlim = c(min(a), max(a)), axes = FALSE)
    box()
}

s <- matrix(2.5, 3, 3)
for(i in 1:3) s[i, i] <- 3
a <- GaussSmoothKernel(voxdim = c(1, 1, 1), ksize = 5, sigma = s)
##f.grid(1,5)
par(mfrow = c(1, 5))
for(i in 1:5){
    image(a[i, , ], zlim = c(min(a), max(a)), axes = FALSE)
    box()
}

#example 1 of GaussSmoothArray

d <- c(10, 10, 10, 20)
mat <- array(rnorm(cumprod(d)[length(d)]), dim = d)
mat[, , 6:10, ] <- mat[, , 6:10 , ] + 3
mask <- array(0, dim = d[1:3])
mask[3:8, 3:8, 3:8] <- 1
b <- GaussSmoothArray(mat, mask = mask, voxdim = c(1, 1, 1), ksize = 5, sigma = diag(1, 3))

f.grid(1,2)
persp(mat[5, , ,1], theta = 90, zlim = c(-2, 6))
persp(b[5, , , 1], theta = 90, zlim = c(-2, 6))         

#example 2 of GaussSmoothArray

d <- c(10, 10, 20, 20)
mat <- array(rnorm(cumprod(d)[length(d)]), dim = d)
mask <- array(1, dim = d[1:3])
#mask[2:9,2:9,2:19]<-1
b <- GaussSmoothArray(mat, voxdim = c(1, 1, 1), ksize = 5, sigma = diag(1, 3), mask = mask, var.norm = TRUE)

##f.grid(1,2)
par(mfrow = c(1, 2))
persp(mat[5, , , 1], theta = 90, zlim = c(-2, 6))
persp(b[5, , , 1], theta = 90, zlim = c(-2, 6))         

#non-linear smoothing

#3D array
d <- rep(10, 3)
a <- array(3, dim = d)
a[, 5:10, 5:10] <- 7
a <- a + array(rnorm(n = 1000, sd = 1), dim = d)

h <- NonLinearSmoothArray(a, voxdim = c(1, 1, 1), radius = 2, sm = 2)

par(mfrow = c(2, 2))
image(a[1, , ], zlim = c(-1, 12)) ; title("Before smoothing")
image(h[1, , ], zlim = c(-1, 12)) ; title("After smoothing")
persp(a[1, , ], zlim = c(-1, 12))
persp(h[1, , ], zlim = c(-1, 12))

#4D array
d <- c(10, 10, 10, 20)
a <- array(1, dim = d)
a[, , 6:10, ] <- 2
a <- a + array(rnorm(20000, sd = .1), dim = d)

h <- NonLinearSmoothArray(a, voxdim = c(1, 1, 1), radius = 2, sm = 3)

f.grid(10,10)
for(i in 1:10){
    for(j in 10:1){
        plot(a[1, i, j, ], type = "l", ylim = c(0, 3), axes = FALSE) ; box()
        lines(h[1, i, j, ], col = 2)
    }
}

par(oldpar)

# require(tcltk) || stop("tcltk support is absent")

local({

    gui.env <- environment()  # capture this local environment

    gui.file<-function(){
        tcltk::tclvalue(file.name) <- tcltk::tcl("tk_getOpenFile")   }
    
    
    gui.mask<-function(){
        tcltk::tclvalue(mask) <- tcltk::tcl("tk_getOpenFile")  }    
    
    
    
    gui.ica<-function(...){
        
        if(tcltk::tclvalue(mask) == "" && tcltk::tclvalue(create.mask) == 0){
            err1 <- tcltk::tktoplevel()
            err1.f1 <- tcltk::tkframe(err1, relief="groove", borderwidth = 2)
            err1.label <- tcltk::tklabel(err1.f1, text = "Either select a mask file or select create mask", bg = "#aaaaaa", pady = 20, padx = 20)
            tcltk::tkgrid(err1.label)
            tcltk::tkgrid(err1.f1)
            return()
        }
        
        if(tcltk::tclvalue(mask) != "" && tcltk::tclvalue(create.mask) == 0) msk <- tcltk::tclvalue(mask)
        if(tcltk::tclvalue(mask) == "" && tcltk::tclvalue(create.mask) == 1) msk <- NULL
        v.norm <- 1
        if(tcltk::tclvalue(var.norm) == 0) v.norm <- 0
        sl <- NULL
        if(tcltk::tclvalue(slices) == 0) sl <- "all"

        if (tcltk::tclvalue(spatial.or.temporal) == "spatial") is.spatial <- 1 else is.spatial <- 0
        
        cat("Computations have begun. Please, be patient ...\n")

        gui.env$tmp.ica.obj <- f.icast.fmri(foncfile = tcltk::tclvalue(file.name),
                               maskfile = msk,
                               is.spatial = is.spatial,
                               n.comp.compute = as.numeric(tcltk::tclvalue(n.comp.compute)),
                               n.comp = as.numeric(tcltk::tclvalue(n.comp)),
                               hp.filter=TRUE)


        
        cat("done\n")
        #if (exists("tmp.ica.obj")) rm(tmp.ica.obj, envir = .GlobalEnv)
        gc(F)
        
    }
    
    
    gui.end<-function(...){
        #if (exists("tmp.ica.obj")) rm(tmp.ica.obj, envir = .GlobalEnv)
        tcltk::tkdestroy(base.ica)
    }




    
    
    ##set tcl variables
    file.name <- tcltk::tclVar()
    mask <- tcltk::tclVar()
    n.comp <- tcltk::tclVar("")
    var.norm <- tcltk::tclVar("0")
    n.comp.compute <- tcltk::tclVar("1")
    slices <- tcltk::tclVar("0")
    create.mask <- tcltk::tclVar("0")
    save.r <- tcltk::tclVar()
    jpeg <- tcltk::tclVar()
    comp <- tcltk::tclVar()
    spatial.or.temporal <- tcltk::tclVar("spatial")
   
    #set up base GUI window
    if(.Platform$OS.type == "windows") flush.console()
    
    base.ica <- tcltk::tktoplevel(bg="#555555")
    tcltk::tkwm.title(base.ica, "Spatial or Temporal ICA for fMRI datasets")
    
    
    #frame to contain file selection
    ica.f1 <- tcltk::tkframe(base.ica, relief = "groove", borderwidth = 2, bg = "#555555")
    
    ica.file.entry <- tcltk::tkentry(ica.f1, textvariable = file.name, width = 50, bg = "#ffffff")
    ica.file.find.but <- tcltk::tkbutton(ica.f1, text = "Select File", width = 15, command = gui.file, bg = "#aaaaaa", anchor = "c")
    tcltk::tkgrid(ica.file.find.but, ica.file.entry, pady = 10, padx = 10)
    
    ica.mask.entry <- tcltk::tkentry(ica.f1, textvariable = mask, width = 50, bg = "#ffffff")
    ica.mask.find.but <- tcltk::tkbutton(ica.f1, text = "Select Mask File", width = 15, command = gui.mask, bg = "#aaaaaa")
    tcltk::tkgrid(ica.mask.find.but, ica.mask.entry, padx = 10, pady = 10)

    tcltk::tkgrid(ica.f1)
    
    #frame for number of components       
    ica.f2 <- tcltk::tkframe(base.ica, relief = "groove", borderwidth = 2, bg = "#555555")
    
    ica.n.comp.radio <- tcltk::tkradiobutton(ica.f2)
    ica.n.comp.label <- tcltk::tklabel(ica.f2, text = "Enter number of components to extract", bg = "#aaaaaa")      
    ica.n.comp.entry <- tcltk::tkentry(ica.f2, textvariable = n.comp, width = 5, bg = "#ffffff")
    ica.n.comp.compute <- tcltk::tklabel(ica.f2, text = "Or automatic choice", bg = "#aaaaaa")
    ica.n.comp.compute.radio <- tcltk::tkradiobutton(ica.f2)

    tcltk::tkconfigure(ica.n.comp.radio,variable=n.comp.compute,value="0")
    tcltk::tkconfigure(ica.n.comp.compute.radio,variable=n.comp.compute,value="1")
    
    
    tcltk::tkgrid(ica.n.comp.radio,ica.n.comp.label, ica.n.comp.entry, ica.n.comp.compute,ica.n.comp.compute.radio, padx = 10, pady = 10)
    
    tcltk::tkgrid(ica.f2, sticky = "ew")
     
       
    #frame for options
    ica.f3 <- tcltk::tkframe(base.ica, relief = "groove", borderwidth = 2, bg = "#555555")
    
    ica.normalise.but <- tcltk::tkradiobutton(ica.f3) 
    ica.slices.but <- tcltk::tkradiobutton(ica.f3) 
    tcltk::tkconfigure(ica.normalise.but,variable=spatial.or.temporal,value="spatial")
    tcltk::tkconfigure(ica.slices.but,variable=spatial.or.temporal,value="temporal")

    
    tcltk::tkgrid(tcltk::tklabel(ica.f3,text="Spatial ICA ", bg = "#aaaaaa"),ica.normalise.but,tcltk::tklabel(ica.f3,text="Temporal ICA ", bg = "#aaaaaa"), ica.slices.but, padx = 30, pady = 10)
    tcltk::tkgrid(ica.f3, sticky = "ew")



  
    #frame for start and end buttons     
    fr3 <- tcltk::tkframe(base.ica, borderwidth = 2, bg = "#555555")
    go.but<- tcltk::tkbutton(fr3, text = "Start", bg = "#aaaaaa", command = gui.ica)
    q.but <- tcltk::tkbutton(fr3, text = "Quit",
                      command = gui.end, bg = "#aaaaaa")
    tcltk::tkgrid(go.but, q.but, padx = 30, pady = 20)
    tcltk::tkgrid(fr3)
    
         tcltk::tkwait.window(base.ica)

})

#require(tcltk) || stop("tcltk support is absent")

local({
 
    wrap.file <- function() tcltk::tclvalue(file.name) <- tcltk::tcl("tk_getOpenFile")
    
    wrap.mask <- function() tcltk::tclvalue(mask) <- tcltk::tcl("tk_getOpenFile") 
    
    do <- function(){
        if(tcltk::tclvalue(alt) == "File Summary") fs()
        if(tcltk::tclvalue(alt) == "Plot Time Series") pts()
        if(tcltk::tclvalue(alt) == "Plot Periodogram") period()
        if(tcltk::tclvalue(alt) == "Image Slice") im.sl()
        if(tcltk::tclvalue(alt) == "Image Volume") im.vol() 
        if(tcltk::tclvalue(alt) == "Movie") im.mov() 
        if(tcltk::tclvalue(alt) == "Spectral Summary") im.spec()
    }
    
    fs <- function(...) f.analyze.file.summary(tcltk::tclvalue(file.name))
    
    pts <- function(...) {
        plot(f.read.analyze.ts(tcltk::tclvalue(file.name),
                               as.numeric(tcltk::tclvalue(x)),
                               as.numeric(tcltk::tclvalue(y)),
                               as.numeric(tcltk::tclvalue(z))),
             typ = "l", ylab = "fMRI response",
             xlab = "Scans")
    }

    period <- function(...){
        oldpar <- par(mfrow = c(1, 1), mar = c(4, 4, 5, 5))
        a <- f.read.analyze.ts(tcltk::tclvalue(file.name),
                               as.numeric(tcltk::tclvalue(x)),
                               as.numeric(tcltk::tclvalue(y)),
                               as.numeric(tcltk::tclvalue(z)))
        b <- fft(a) / sqrt(2 * pi * length(a))
        b <- b[10:floor(length(b) / 2) + 1]
        b <- Mod(b)^2
        plot(b, ylab = "Periodogram", xlab = "Fourier Frequency")
        par(oldpar)
    }
    
    im.sl <- function(...){
        oldpar <- par(mfrow = c(1, 1), mar = c(0, 0, 0, 0))
        a <- f.read.analyze.slice(tcltk::tclvalue(file.name),
                                  as.numeric(tcltk::tclvalue(z)),
                                  as.numeric(tcltk::tclvalue(t)))
        
        image(a)
        par(oldpar)
    }
    
    im.vol <- function(...){
        a <- f.read.analyze.header(tcltk::tclvalue(file.name))$dim
        d <- ceiling(sqrt(a[4]))
        oldpar <- par(mfrow =c(d, d), mar = c(0, 0, 0, 0))
        b <- array(0, dim = a[2:4])
        for(i in 1:a[4]){
            b[, , i] <- f.read.analyze.slice(tcltk::tclvalue(file.name),
                                             i,
                                             as.numeric(tcltk::tclvalue(t)))
        }
        for(i in 1:a[4]){
            image(b[, , i], axes = FALSE)
            box()
        }
        par(oldpar)
    }
    
    im.mov <- function(...){
        oldpar <- par(mfrow = c(1, 1), mar = c(0, 0, 0, 0))
        a <- f.read.analyze.header(tcltk::tclvalue(file.name))$dim
        b <- array(0, dim = c(a[2], a[3], a[5]))
        for(i in 1:a[5]){
            b[, , i] <- f.read.analyze.slice(tcltk::tclvalue(file.name),
                                             as.numeric(tcltk::tclvalue(z)),
                                             i)
        }
        image(b[, , 1], axes = FALSE)
        for(i in 2:a[5]){
            image(b[, , i], axes = FALSE, add = TRUE)
        }
        par(oldpar)
    }
    
    im.spec <- function(...){
        oldpar <- par(mfrow = c(1, 1), mar = c(4, 4, 5, 5))
        if(tcltk::tclvalue(mask) == "") tcltk::tclvalue(mask) <- FALSE
        a <- f.spectral.summary(tcltk::tclvalue(file.name), tcltk::tclvalue(mask))
        par(oldpar)
    }
    
    ## set up tclVar variables

    mask <- tcltk::tclVar("sdasd")
    alt <- tcltk::tclVar()
    x <- tcltk::tclVar()
    y <- tcltk::tclVar()
    z <- tcltk::tclVar()
    t <- tcltk::tclVar()
    
    #set up base GUI window
    if(.Platform$OS.type == "windows") flush.console()
    
    base <- tcltk::tktoplevel()
    tcltk::tkwm.title(base, "ANALYZE file explore")
    f1 <- tcltk::tkframe(base, relief = "groove", borderwidth = 2)

    file.name <- tcltk::tclVar()
    tcltk::tkpack(tcltk::tkentry(f1, textvariable = file.name, width = 40))
    
    file.find.but <- tcltk::tkbutton(f1, text = "Select File", command = wrap.file)
    tcltk::tkpack(file.find.but)
    
    mask <- tcltk::tclVar()
    tcltk::tkpack(tcltk::tkentry(f1, textvariable = mask, width = 40))
    mask.find.but <- tcltk::tkbutton(f1, text = "Select Mask File", command = wrap.mask)
    tcltk::tkpack(mask.find.but)
    
    opt.rbuts <- tcltk::tkframe(base, relief = "groove", borderwidth = 2)
    
    tcltk::tkpack(tcltk::tklabel(opt.rbuts, text = "Options"))

    alt <- tcltk::tclVar()
    for (i in c("File Summary",
                "Plot Time Series",
                "Plot Periodogram",
                "Image Slice",
                "Image Volume",
                "Movie",
                "Spectral Summary")) {
        tmp <- tcltk::tkradiobutton(opt.rbuts, text = i, variable = alt, value = i)
        tcltk::tkpack(tmp, anchor = "w")
    }
    fr2 <- tcltk::tkframe(base, relief = "groove", borderwidth = 2)
    x <- tcltk::tclVar()
    x.entry <- tcltk::tkentry(fr2, textvariable = x)
    y <- tcltk::tclVar()
    y.entry <- tcltk::tkentry(fr2, textvariable = y)
    z <- tcltk::tclVar()
    z.entry <- tcltk::tkentry(fr2, textvariable = z)
    t <- tcltk::tclVar()
    t.entry <- tcltk::tkentry(fr2, textvariable = t)
    tcltk::tkgrid(f1)
    
    tcltk::tkgrid(tcltk::tklabel(fr2, text = "Variables"), columnspan = 2)
    tcltk::tkgrid(tcltk::tklabel(fr2, text = "x variable"), x.entry)
    tcltk::tkgrid(tcltk::tklabel(fr2, text = "y variable"), y.entry)
    tcltk::tkgrid(tcltk::tklabel(fr2, text = "z variable"), z.entry)
    tcltk::tkgrid(tcltk::tklabel(fr2, text = "t variable"), t.entry)
    tcltk::tkgrid(opt.rbuts)
    tcltk::tkgrid(fr2)
    
    fr3 <- tcltk::tkframe(base, borderwidth = 2)
    q.but <- tcltk::tkbutton(fr3, text = "Quit",
                      command = function() tcltk::tkdestroy(base))
    ok.but <- tcltk::tkbutton(fr3, text = "OK", command = do)
    tcltk::tkgrid(ok.but, q.but)
    tcltk::tkgrid(fr3)
    
})

library(fmri, lib.loc = "./tmp/")
## GRF simulations and checking of Bonferroni and GRF thresholds

ksize <- 9
d <- c(64, 64, 21)
FWHM <- 9
sigma <- diag(FWHM^2, 3) / (8 * log(2))
voxdim <- c(2, 2, 4)

filtermat <- GaussSmoothKernel(voxdim, ksize, sigma)
image(filtermat[(ksize + 1) / 2, , ])

mask <- f.read.analyze.volume(file = "/users/marchini/fmri/fmri_data/jm2.null.mc.mask.img")[, , , 1]
num.vox <- sum(mask)

ans <- 1:10000
for(i in 1:10000) {
    print(i)
    ans[i] <- Sim.3D.GRF(d = d, voxdim = voxdim, sigma = sigma, ksize = ksize, mask = mask, type = "max")$max
}

thr.bonf <- Threshold.Bonferroni(p.val = 0.05, n = num.vox)
thr.grf <- Threshold.GRF(p.val = 0.05, sigma = sigma, voxdim = voxdim, num.vox = num.vox)

thr.bonf
thr.grf

sum(ans > thr.bonf)
sum(ans > thr.grf)

a <- sort(ans)
p <- 1:10000 / 10000
plot(a, p, typ = "l")

p1 <- 1 - EC.3D(a, sigma = sigma, voxdim = voxdim, num.vox = sum(mask))
lines(a, p1, col = 2)
